routes/web.php
<?php

use App\Http\Controllers\Admin\CategoryController;
use App\Http\Controllers\Admin\CustomerController;
use App\Http\Controllers\Admin\DashboardController;
use App\Http\Controllers\Admin\OrderController;
use App\Http\Controllers\Admin\ProductController;
use App\Http\Controllers\Admin\ProfileController;
use App\Http\Controllers\Admin\SliderController;
use App\Http\Controllers\Admin\UserController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});
# admin
Route::controller(DashboardController::class)->group(function() {
    Route::get('/admin/dashboard', 'index')->name('admin.dashboard.index');
});
# admin / categories
Route::resource('/admin/categories', CategoryController::class, ['as' => 'admin']);

# admin / products
Route::resource('/admin/products', ProductController::class, ['as' => 'admin']);

# admin / orders
// Route::resource('/admin/orders', OrderController::class, ['only' => ['index', 'show'], 'as' => 'admin']);
Route::get('/admin/orders', [OrderController::class, 'index'])->name('admin.orders.index');
Route::get('/admin/orders/{invoice}', [OrderController::class, 'show'])->name('admin.orders.show');

# admin / customers
Route::get('/admin/customers', [CustomerController::class, 'index'])->name('admin.customers.index');

# admin / sliders
Route::resource('/admin/sliders', SliderController::class, ['only' => ['index', 'store', 'destroy'], 'as' => 'admin']);

# admin / profile
Route::get('/admin/profile', [ProfileController::class, 'index'])->name('admin.profile.index');

# admin / users
Route::resource('/admin/users', UserController::class, ['as' => 'admin']);

app/Models/User.php
<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;

use Illuminate\Database\Eloquent\Casts\Attribute;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Fortify\TwoFactorAuthenticatable;

use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable, TwoFactorAuthenticatable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    protected function avatarUrl(): Attribute
    {
        return Attribute::make(
            get: fn ($value) => 'https://ui-avatars.com/api/?name=' . str_replace(' ', '+', $this->name) . '&background=4e73df&color=ffffff&size=100',
        );
    }
}

app/Http/Controllers/Admin/UserController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Validation\Rule;

class UserController extends Controller
{
    public function __construct()
    {
        $this->middleware(['auth', 'preventBackHistory']);
    }

    # get all data users
    public function index()
    {
        # action get all data users
        $users = User::latest()->when(request()->q, function ($users) {
            $users = $users->where('name', 'like', '%' . request()->q . '%');
        })->whereNot('id', auth()->user()->id)->paginate(15);

        # return view
        return view('admin.users.index', compact('users'));
    }

    # view create user
    public function create()
    {
        $user = new User();
        return view('admin.users.create', compact('user'));
    }

    # process create user
    public function store(Request $request)
    {
        # validation
        $request->validate([
            'name' => ['required', 'min:3', 'max:255'],
            'email' => ['required', 'email', Rule::unique('users', 'name')],
            'password' => ['required', 'min:3', 'max:255', 'confirmed'],
        ]);

        # action create user
        User::create([
            'name' => $request->name,
            'email' => $request->email,
            'password' => bcrypt($request->password),
        ]);

        # redirect
        return to_route('admin.users.index')->with('success', 'Data user has been created');
    }

    public function show(User $user)
    {

    }

    # view edit user
    public function edit(User $user)
    {
        return view('admin.users.edit', compact('user'));
    }

    # process update user
    public function update(Request $request, User $user)
    {
        # validation
        $request->validate([
            'name' => ['required', 'min:3', 'max:255'],
            'email' => ['required', 'email', Rule::unique('users', 'name')->ignore($user)],
            'password' => ['nullable', 'min:8', 'max:255', 'confirmed'],
        ]);

        # action update user
        $user->update([
            'name' => $request->name,
            'email' => $request->email,
            'password' => bcrypt($request->password),
        ]);

        # redirect
        return to_route('admin.users.index')->with('success', 'Data user has been updated');
    }

    # process delete user
    public function destroy(User $user)
    {
        # action delete user
        $user->delete();

        return response()->json([
            'status' => 'success',
        ]);
    }
}

resources/views/admin/users/create.blade.php
@extends('layouts.app', ['title' => 'Add User - GreenK Online Shop'])
@section('content')
<div class="container-fluid">
  <div class="row">
    <div class="col-md-12">
      <div class="card border-0 shadow">
        {{-- card header --}}
        <div class="card-header">
          <h6 class="m-0 font-weight-bold"><i class="fas fa-user-circle mr-2"></i> Add User</h6>
        </div>
        {{-- card body --}}
        <div class="card-body">
          {{-- form add user --}}
          <form action="{{ route('admin.users.store') }}" method="POST" enctype="multipart/form-data">
           @include('admin.users.form', ['submit' => 'Save'])
          </form>
        </div>
      </div>
    </div>
  </div>
</div>
@endsection

resources/views/admin/users/edit.blade.php
@extends('layouts.app', ['title' => 'Edit User - GreenK Online Shop'])
@section('content')
<div class="container-fluid">
  <div class="row">
    <div class="col-md-12">
      <div class="card border-0 shadow">
        {{-- card header --}}
        <div class="card-header">
          <h6 class="m-0 font-weight-bold"><i class="fas fa-user-circle mr-2"></i> Edit User</h6>
        </div>
        {{-- card body --}}
        <div class="card-body">
          {{-- form add user --}}
          <form action="{{ route('admin.users.update', $user) }}" method="POST" enctype="multipart/form-data">
            @method('PUT')
            @include('admin.users.form', ['submit' => 'Update'])
          </form>
        </div>
      </div>
    </div>
  </div>
</div>
@endsection

resources/views/admin/users/form.blade.php
@csrf

<div class="row">
  {{-- full name --}}
  <div class="col-md-6">
    <div class="form-group">
      <label for="name" class="form-label">Full Name</label>
      <input type="text" name="name" class="form-control @error('name') is-invalid @enderror" id="name" value="{{ old('name', $user->name) }}" placeholder="Full Name">
      @error('name')
      <div class="invalid-feedback">
        <strong> {{ $message }}</strong>
      </div>
      @enderror
    </div>
  </div>
  {{-- email address --}}
  <div class="col-md-6">
    <div class="form-group">
      <label for="email" class="form-label">Email Address</label>
      <input type="email" name="email" class="form-control @error('email') is-invalid @enderror" id="email" value="{{ old('email', $user->email) }}" placeholder="Email Address">
      @error('email')
      <div class="invalid-feedback">
        <strong> {{ $message }}</strong>
      </div>
      @enderror
    </div>
  </div>
</div>

<div class="row">
  {{-- password --}}
  <div class="col-md-6">
    <div class="form-group">
      <label for="password" class="form-label">Password</label>
      <input type="password" name="password" class="form-control @error('password') is-invalid @enderror" id="password" placeholder="Password">
      @error('password')
      <div class="invalid-feedback">
        <strong> {{ $message }}</strong>
      </div>
      @enderror
    </div>
  </div>
  
  {{-- confirm password --}}
  <div class="col-md-6">
    <div class="form-group">
      <label for="password-confirm" class="form-label">Password Confirm</label>
      <input type="password" name="password_confirmation" class="form-control" placeholder="Password Confirm">
    </div>
  </div>
</div>
{{-- button submit --}}
<button class="btn btn-primary mr-1 btn-submit" type="submit">
  {{ $submit }}
</button>

resources/views/admin/users/index.blade.php
@extends('layouts.app', ['title' => 'Users - GreenK Online Shop'])
@section('content')
<div class="container-fluid">
  <div class="row">
    <div class="col-md-12">
      <div class="card border-0 shadow">
        {{-- card header --}}
        <div class="card-header">
          <h6 class="m-0 font-weight-bold"><i class="fas fa-user-circle mr-2"></i> Users</h6>
        </div>
        {{-- card body --}}
        <div class="card-body">
          <form action="{{ route('admin.users.index') }}" method="GET">
            <div class="row">
              <div class="col-md-4 mb-3 mb-md-0">
                <a href="{{ route('admin.users.create') }}" class="btn btn-primary btn-md">
                  Add User
                </a>
              </div>

              {{-- search users--}}
              <div class="col-md-8">
                <div class="form-group">
                  <div class="input-group">
                    <input type="search" class="form-control form-control-md" name="q" placeholder="Search Users...">
                    <div class="input-group-append">
                      <button type="submit" class="btn btn-primary"><i class="fa fa-search"></i></button>
                    </div>
                  </div>
                </div>
              </div>

            </div>
          </form>
          {{-- table of users --}}
          <div class="table-responsive">
            <table class="table table-hover">
              <thead>
                <tr>
                  <th scope="col" style="text-align: center;width: 6%">No.</th>
                  <th scope="col">Name</th>
                  <th scope="col">Email</th>
                  <th scope="col" style="width: 15%;text-align: center">Action</th>
                </tr>
              </thead>
              <tbody>
                @forelse ($users as $user)
                <tr>
                  <td scope="row" class="text-center">{{ $users->firstItem() + $loop->index }}</td>
                  <td scope="row">{{ $user->name }}</td>
                  <td scope="row">{{ $user->email }}</td>
                  <td scope="row" class="text-center">
                    <a href="{{ route('admin.users.edit', $user->id) }}" class="btn btn-sm btn-primary">
                      <i class="fa fa-pencil-alt"></i>
                    </a>
                    <button onclick="Delete(this.id)" class="btn btn-sm btn-danger" id="{{ $user->id }}">
                      <i class="fa fa-trash"></i>
                    </button>
                  </td>
                </tr>
                @empty
                <tr>
                  <td scope="row" colspan="4">
                    <div class="text-danger text-center">No data users.</div>
                  </td>
                </tr>
                @endforelse
              </tbody>
            </table>
            {{-- pagination --}}
            <div style="text-align: center">
              {{ $users->links() }}
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>

<script>
  /* ajax delete */
  function Delete(id) {
    var id = id;
    var token = $("meta[name='csrf-token']").attr("content");

    Swal.fire({
      title: "Want to delete this data?"
      , text: "Data that has been deleted cannot be recovered"
      , icon: "warning"
      , showCancelButton: true
      , confirmButtonColor: '#3085d6'
      , cancelButtonColor: '#d33'
      , confirmButtonText: 'Yes, delete it!'
    }).then((result) => {
      if (result.isConfirmed) {
        jQuery.ajax({
          url: "/admin/users/" + id
          , data: {
            "id": id
            , "_token": token
          }
          , type: "DELETE"
        });
        Swal.fire({
          position: 'center'
          , icon: 'success'
          , title: 'Data user has been deleted'
          , showConfirmButton: false
          , timer: 1500
        , }).then(function() {
          location.reload();
        });
      }
    });
  }

</script>
@endsection